public class LinFrac
{
    public Complex A,B,C,D;

    // Constructor given matrix elements
    public LinFrac(Complex a, Complex b, Complex c, Complex d)
    {
	Complex e = det(a,b,c,d).sqrt().inv();
	A=a.mul(e); B=b.mul(e); C=c.mul(e); D=d.mul(e);
    }
    public Complex transform(Complex z)
    {
	return z.mul(A).add(B).div( z.mul(C).add(D) );
    }
    public LinFrac mul(LinFrac Y)
    {
	Complex newA, newB, newC, newD;

	newA = A.mul(Y.A).add(B.mul(Y.C));
	newB = A.mul(Y.B).add(B.mul(Y.D));
	newC = C.mul(Y.A).add(D.mul(Y.C));
	newD = C.mul(Y.B).add(D.mul(Y.D));
	return new LinFrac(newA, newB, newC, newD);
    }
    // only called when building a new linfrac; stored so that det=1
    public static Complex det(Complex a, Complex b, Complex c, Complex d)
    {
	return (a.mul(d).sub(b.mul(c)));
    }
    public LinFrac inv()
    {
	return new LinFrac(D, B.realMul(-1.0), C.realMul(-1.0), A);
    }
    // Move p1,p2,p3 to 0,1,inf respectively
    public static LinFrac toZOI(Complex p1, Complex p2, Complex p3)
    {
	return new LinFrac(p2.sub(p3), p1.mul(p3).sub(p1.mul(p2)),
			   p2.sub(p1), p1.mul(p3).sub(p3.mul(p2)));
    }
    // three points to three other points
    public static LinFrac threeToThree(Complex p1, Complex p2, Complex p3, Complex q1, Complex q2, Complex q3)
    {
	LinFrac X;
	LinFrac Y;
	X = toZOI(p1,p2,p3);
	Y = toZOI(q1,q2,q3).inv();
	return Y.mul(X);
    }
    // element of PSL_2(R) that moves 0 to a
    public static LinFrac zeroToPoint(Complex a)
    {
	return new LinFrac(Complex.U,a,a.conj(),Complex.U);
    }
}
