import java.awt.*;
import java.awt.geom.*;

class PoincareTriangle {
    Complex V[];
    PoincareSegment E[];

    // CONSTRUCTORS

    // NOTE: vertices must be specified in counterclockwise order!
    public PoincareTriangle(Complex v[]) {
	V = new Complex[3];
	V[0] = v[0];
	V[1] = v[1];
	V[2] = v[2];
	compute();
    }

    public PoincareTriangle(Complex v0, Complex v1, Complex v2) {
	V = new Complex[3];
	V[0] = v0;
	V[1] = v1;
	V[2] = v2;
	compute();
    }

    private void compute()
    {
	E = new PoincareSegment[3];
	E[0] = new PoincareSegment(V[0], V[1]);
	E[1] = new PoincareSegment(V[1], V[2]);
	E[2] = new PoincareSegment(V[2], V[0]);
    }

    private static final int ind3(int i)
    {
	return (i % 3);
    }

    public PoincareSegment getEdge(int i)
    {
	return E[i];
    }

    public Complex getVertex(int i)
    {
	return V[i];
    }

    public boolean isInside(Complex p)
    {
	int a,b,c;

	a = E[0].getSide(p);
	b = E[1].getSide(p);
	c = E[2].getSide(p);
	//	System.out.println("("+a+","+b+","+c+")");
	return ((a > 0) && (b > 0) && (c > 0));
    }

    public void drawOn(Graphics2D g)
    {
	for (int i=0; i<3; i++)
	    E[i].drawOn(g);
    }

}
